package main

import (
	"log"
	"os"

	"git.wisellama.rocks/Project-Ely/project-ely/internal"
	"git.wisellama.rocks/Project-Ely/project-ely/internal/channels"
	"git.wisellama.rocks/Wisellama/gopackagebase"
	"git.wisellama.rocks/Wisellama/gosimpleconf"
)

const (
	configFile = "project-ely.conf"
)

var defaultConfig gosimpleconf.ConfigMap = gosimpleconf.ConfigMap{
	"game.title":      "Project Ely",
	"game.framerate":  "60",
	"log.utcTime":     "false",
	"log.writeToFile": "false",
}

func main() {
	var err error

	baseConfig, err := gopackagebase.Initialize(configFile, defaultConfig)
	if err != nil {
		log.Fatalf("error initializing: %v", err)
	}
	if baseConfig == nil {
		log.Fatalf("baseConfig was nil")
	}
	defer baseConfig.Cancel()

	// Run the program
	log.Printf("=== Starting %v ===", baseConfig.ConfigMap["game.title"])
	channels.RL.Main(func() {
		err = internal.Run(baseConfig.Ctx, baseConfig.ConfigMap)
	})
	if err != nil {
		log.Printf("%v\n", err)
		os.Exit(1)
	}

	log.Printf("Exited gracefully!\n")
}
